Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.log4jdbc
Class PreparedStatementSpy

    java.lang.Object
      net.sf.log4jdbc.StatementSpy
          net.sf.log4jdbc.PreparedStatementSpy

All Implemented Interfaces:
  PreparedStatement, Spy, Statement

Direct Known Subclasses:
  CallableStatementSpy

public class PreparedStatementSpy
extends StatementSpy
implements PreparedStatement

Wraps a PreparedStatement and reports method calls, returns and exceptions.

Author:
  Arthur Blake

Field Summary
`protected List` | `argTrace` holds list of bind variables for tracing
`protected net.sf.log4jdbc.RdbmsSpecifics` | `rdbmsSpecifics` RdbmsSpecifics for formatting SQL for the given RDBMS.
`protected PreparedStatement` | `realPreparedStatement` The real PreparedStatement that this PreparedStatementSpy wraps.

Fields inherited from class net.sf.log4jdbc.StatementSpy
`connectionSpy, currentBatch, realStatement`

Fields inherited from interface java.sql.Statement
`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

Constructor Summary
`PreparedStatementSpy(String sql, ConnectionSpy connectionSpy, PreparedStatement realPreparedStatement)` Create a prepared statement spy for logging activity of another PreparedStatement.

Method Summary
`void` | `addBatch()` Adds a set of parameters to this `PreparedStatement` object's batch of commands.
`protected void` | `argTraceSet(int i, String typeHelper, Object arg)` Store an argument (bind variable) into the argTrace list (above) for later dumping.
`void` | `clearParameters()` Clears the current parameter values immediately.
`protected String` | `dumpedSql()`
`boolean` | `execute()` Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement.
`ResultSet` | `executeQuery()` Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.
`int` | `executeUpdate()` Executes the SQL statement in this `PreparedStatement` object, which must be an SQL `INSERT`, `UPDATE` or `DELETE` statement; or an SQL statement that returns nothing, such as a DDL statement.
`String` | `getClassType()` Get the type of class being spied upon.
`ResultSetMetaData` | `getMetaData()` Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.
`ParameterMetaData` | `getParameterMetaData()` Retrieves the number, types and properties of this `PreparedStatement` object's parameters.
`protected void` | `reportAllReturns(String methodCall, String msg)` Report (for logging) that a method returned.
`void` | `setArray(int i, Array x)` Sets the designated parameter to the given `Array` object.
`void` | `setAsciiStream(int parameterIndex, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBigDecimal(int parameterIndex, BigDecimal x)` Sets the designated parameter to the given `java.math.BigDecimal` value.
`void` | `setBinaryStream(int parameterIndex, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBlob(int i, Blob x)` Sets the designated parameter to the given `Blob` object.
`void` | `setBoolean(int parameterIndex, boolean x)` Sets the designated parameter to the given Java `boolean` value.
`void` | `setByte(int parameterIndex, byte x)` Sets the designated parameter to the given Java `byte` value.
`void` | `setBytes(int parameterIndex, byte[] x)` Sets the designated parameter to the given Java array of bytes.
`void` | `setCharacterStream(int parameterIndex, Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` | `setClob(int i, Clob x)` Sets the designated parameter to the given `Clob` object.
`void` | `setDate(int parameterIndex, Date x)` Sets the designated parameter to the given `java.sql.Date` value.
`void` | `setDate(int parameterIndex, Date x, Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void` | `setDouble(int parameterIndex, double x)` Sets the designated parameter to the given Java `double` value.
`void` | `setFloat(int parameterIndex, float x)` Sets the designated parameter to the given Java `float` value.
`void` | `setInt(int parameterIndex, int x)` Sets the designated parameter to the given Java `int` value.
`void` | `setLong(int parameterIndex, long x)` Sets the designated parameter to the given Java `long` value.
`void` | `setNull(int parameterIndex, int sqlType)` Sets the designated parameter to SQL `NULL`.
`void` | `setNull(int paramIndex, int sqlType, String typeName)` Sets the designated parameter to SQL `NULL`.
`void` | `setObject(int parameterIndex, Object x)` Sets the value of the designated parameter using the given object.
`void` | `setObject(int parameterIndex, Object x, int targetSqlType)` Sets the value of the designated parameter with the given object.
`void` | `setObject(int parameterIndex, Object x, int targetSqlType, int scale)` Sets the value of the designated parameter with the given object.
`void` | `setRef(int i, Ref x)` Sets the designated parameter to the given `REF(<structured-type>)` value.
`void` | `setShort(int parameterIndex, short x)` Sets the designated parameter to the given Java `short` value.
`void` | `setString(int parameterIndex, String x)` Sets the designated parameter to the given Java `String` value.
`void` | `setTime(int parameterIndex, Time x)` Sets the designated parameter to the given `java.sql.Time` value.
`void` | `setTime(int parameterIndex, Time x, Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void` | `setTimestamp(int parameterIndex, Timestamp x)` Sets the designated parameter to the given `java.sql.Timestamp` value.
`void` | `setTimestamp(int parameterIndex, Timestamp x, Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void` | `setUnicodeStream(int parameterIndex, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setURL(int parameterIndex, URL x)` Sets the designated parameter to the given `java.net.URL` value.

Methods inherited from class net.sf.log4jdbc.StatementSpy
`addBatch, cancel, clearBatch, clearWarnings, close, execute, execute, execute, execute, executeBatch, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getConnectionNumber, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, reportException, reportException, reportException, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportReturn, reportSql, reportSqlTiming, reportStatementSql, reportStatementSqlTiming, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setQueryTimeout`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.sql.Statement
`addBatch, cancel, clearBatch, clearWarnings, close, execute, execute, execute, execute, executeBatch, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setQueryTimeout`

Field Detail

### argTrace

    protected final List argTrace

  holds list of bind variables for tracing

### realPreparedStatement

    protected PreparedStatement realPreparedStatement

  The real PreparedStatement that this PreparedStatementSpy wraps.

### rdbmsSpecifics

    protected net.sf.log4jdbc.RdbmsSpecifics rdbmsSpecifics

  RdbmsSpecifics for formatting SQL for the given RDBMS.

Constructor Detail

### PreparedStatementSpy

    public PreparedStatementSpy(String sql,
                                ConnectionSpy connectionSpy,
                                PreparedStatement realPreparedStatement)

  Create a prepared statement spy for logging activity of another PreparedStatement.

Parameters:
  `sql` - SQL for the prepared statement that is being spied upon.
  `connectionSpy` - ConnectionSpy that was called to produce this PreparedStatement.
  `realPreparedStatement` - The actual PreparedStatement that is being spied upon.

Method Detail

### argTraceSet

    protected void argTraceSet(int i,
                               String typeHelper,
                               Object arg)

  Store an argument (bind variable) into the argTrace list (above) for later dumping.

  Parameters:
    `i` - index of argument being set.
    `typeHelper` - optional additional info about the type that is being set in the arg
    `arg` - argument being bound.

### dumpedSql

    protected String dumpedSql()

### reportAllReturns

    protected void reportAllReturns(String methodCall,
                                    String msg)

  Description copied from class: `StatementSpy`
  Report (for logging) that a method returned. All the other reportReturn methods are conveniance methods that call this method.

  Overrides:
    `reportAllReturns` in class `StatementSpy`
  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `msg` - description of what the return value that was returned. may be an empty String for void return types.

### getClassType

    public String getClassType()

  Description copied from interface: `Spy`
  Get the type of class being spied upon. For example, "Statement", "ResultSet", etc.

  Specified by:
    `getClassType` in interface `Spy`
  Overrides:
    `getClassType` in class `StatementSpy`

### setTime

    public void setTime(int parameterIndex,
                        Time x)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

  Specified by:
    `setTime` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setTime

    public void setTime(int parameterIndex,
                        Time x,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setTime` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the time

### setCharacterStream

    public void setCharacterStream(int parameterIndex,
                                   Reader reader,
                                   int length)
                            throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setCharacterStream` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `reader` - the `java.io.Reader` object that contains the Unicode data
    `length` - the number of characters in the stream

### setNull

    public void setNull(int parameterIndex,
                        int sqlType)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to SQL `NULL`.

  Note: You must specify the parameter's SQL type.

  Specified by:
    `setNull` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `sqlType` - the SQL type code defined in `java.sql.Types`

### setNull

    public void setNull(int paramIndex,
                        int sqlType,
                        String typeName)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

  Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

  Specified by:
    `setNull` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `paramIndex` - the first parameter is 1, the second is 2, ...
    `sqlType` - a value from `java.sql.Types`
    `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or REF

### setRef

    public void setRef(int i,
                       Ref x)
                throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `REF(<structured-type>)` value. The driver converts this to an SQL `REF` value when it sends it to the database.

  Specified by:
    `setRef` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - an SQL `REF` value

### setBoolean

    public void setBoolean(int parameterIndex,
                           boolean x)
                    throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` value when it sends it to the database.

  Specified by:
    `setBoolean` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setBlob

    public void setBlob(int i,
                        Blob x)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.

  Specified by:
    `setBlob` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - a `Blob` object that maps an SQL `BLOB` value

### setClob

    public void setClob(int i,
                        Clob x)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.

  Specified by:
    `setClob` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - a `Clob` object that maps an SQL `CLOB` value

### setArray

    public void setArray(int i,
                         Array x)
                  throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `Array` object. The driver converts this to an SQL `ARRAY` value when it sends it to the database.

  Specified by:
    `setArray` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - an `Array` object that maps an SQL `ARRAY` value

### setByte

    public void setByte(int parameterIndex,
                        byte x)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

  Specified by:
    `setByte` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setUnicodeStream

    public void setUnicodeStream(int parameterIndex,
                                 InputStream x,
                                 int length)
                          throws SQLException

  Deprecated.

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given input stream, which will have the specified number of bytes. A Unicode character has two bytes, with the first byte being the high byte, and the second being the low byte. When a very large Unicode value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from Unicode to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setUnicodeStream` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - a `java.io.InputStream` object that contains the Unicode parameter value as two-byte Unicode characters
    `length` - the number of bytes in the stream

### setShort

    public void setShort(int parameterIndex,
                         short x)
                  throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

  Specified by:
    `setShort` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### execute

    public boolean execute()
                    throws SQLException

  Description copied from interface: `PreparedStatement`
  Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement. Some prepared statements return multiple results; the `execute` method handles these complex statements as well as the simpler form of statements handled by the methods `executeQuery` and `executeUpdate`.

  The `execute` method returns a `boolean` to indicate the form of the first result. You must call either the method `getResultSet` or `getUpdateCount` to retrieve the result; you must call `getMoreResults` to move to any subsequent result(s).

  Specified by:
    `execute` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if the first result is an update count or there is no result
  See Also:
    `Statement.execute(java.lang.String)`, `Statement.getResultSet()`, `Statement.getUpdateCount()`, `Statement.getMoreResults()`

### setInt

    public void setInt(int parameterIndex,
                       int x)
                throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.

  Specified by:
    `setInt` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setLong

    public void setLong(int parameterIndex,
                        long x)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

  Specified by:
    `setLong` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setFloat

    public void setFloat(int parameterIndex,
                         float x)
                  throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `FLOAT` value when it sends it to the database.

  Specified by:
    `setFloat` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setDouble

    public void setDouble(int parameterIndex,
                          double x)
                   throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

  Specified by:
    `setDouble` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setBigDecimal

    public void setBigDecimal(int parameterIndex,
                              BigDecimal x)
                       throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

  Specified by:
    `setBigDecimal` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setURL

    public void setURL(int parameterIndex,
                       URL x)
                throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.net.URL` value. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

  Specified by:
    `setURL` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the `java.net.URL` object to be set

### setString

    public void setString(int parameterIndex,
                          String x)
                   throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

  Specified by:
    `setString` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setBytes

    public void setBytes(int parameterIndex,
                         byte[] x)
                  throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

  Specified by:
    `setBytes` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setDate

    public void setDate(int parameterIndex,
                        Date x)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.sql.Date` value. The driver converts this to an SQL `DATE` value when it sends it to the database.

  Specified by:
    `setDate` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### getParameterMetaData

    public ParameterMetaData getParameterMetaData()
                                           throws SQLException

  Description copied from interface: `PreparedStatement`
  Retrieves the number, types and properties of this `PreparedStatement` object's parameters.

  Specified by:
    `getParameterMetaData` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Returns:
    a `ParameterMetaData` object that contains information about the number, types and properties of this `PreparedStatement` object's parameters
  See Also:
    `ParameterMetaData`

### setDate

    public void setDate(int parameterIndex,
                        Date x,
                        Calendar cal)
                 throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setDate` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the date

### executeQuery

    public ResultSet executeQuery()
                           throws SQLException

  Description copied from interface: `PreparedStatement`
  Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.

  Specified by:
    `executeQuery` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Returns:
    a `ResultSet` object that contains the data produced by the query; never `null`

### setObject

    public void setObject(int parameterIndex,
                          Object x,
                          int targetSqlType,
                          int scale)
                   throws SQLException

  Description copied from interface: `PreparedStatement`

  Sets the value of the designated parameter with the given object. The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.

  The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `Struct`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

  Note that this method may be used to pass database-specific abstract data types.

  Specified by:
    `setObject` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
    `scale` - for java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types, this is the number of digits after the decimal point. For all other types, this value will be ignored.
  See Also:
    `Types`

### setObject

    public void setObject(int parameterIndex,
                          Object x,
                          int targetSqlType)
                   throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.

  Specified by:
    `setObject` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database

### setObject

    public void setObject(int parameterIndex,
                          Object x)
                   throws SQLException

  Description copied from interface: `PreparedStatement`

  Sets the value of the designated parameter using the given object. The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

  The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

  Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `Struct`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

  This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

  Specified by:
    `setObject` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value

### setTimestamp

    public void setTimestamp(int parameterIndex,
                             Timestamp x)
                      throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

  Specified by:
    `setTimestamp` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value

### setTimestamp

    public void setTimestamp(int parameterIndex,
                             Timestamp x,
                             Calendar cal)
                      throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setTimestamp` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the timestamp

### executeUpdate

    public int executeUpdate()
                      throws SQLException

  Description copied from interface: `PreparedStatement`
  Executes the SQL statement in this `PreparedStatement` object, which must be an SQL `INSERT`, `UPDATE` or `DELETE` statement; or an SQL statement that returns nothing, such as a DDL statement.

  Specified by:
    `executeUpdate` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Returns:
    either (1) the row count for `INSERT`, `UPDATE`, or `DELETE` statements or (2) 0 for SQL statements that return nothing

### setAsciiStream

    public void setAsciiStream(int parameterIndex,
                               InputStream x,
                               int length)
                        throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setAsciiStream` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the Java input stream that contains the ASCII parameter value
    `length` - the number of bytes in the stream

### setBinaryStream

    public void setBinaryStream(int parameterIndex,
                                InputStream x,
                                int length)
                         throws SQLException

  Description copied from interface: `PreparedStatement`
  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Specified by:
    `setBinaryStream` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the java input stream which contains the binary parameter value
    `length` - the number of bytes in the stream

### clearParameters

    public void clearParameters()
                         throws SQLException

  Description copied from interface: `PreparedStatement`
  Clears the current parameter values immediately.

  In general, parameter values remain in force for repeated use of a statement. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling the method `clearParameters`.

  Specified by:
    `clearParameters` in interface `PreparedStatement`
  Throws:
    `SQLException`

### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

  Description copied from interface: `PreparedStatement`
  Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.

  Because a `PreparedStatement` object is precompiled, it is possible to know about the `ResultSet` object that it will return without having to execute it. Consequently, it is possible to invoke the method `getMetaData` on a `PreparedStatement` object rather than waiting to execute it and then invoking the `ResultSet.getMetaData` method on the `ResultSet` object that is returned.

  NOTE: Using this method may be expensive for some drivers due to the lack of underlying DBMS support.

  Specified by:
    `getMetaData` in interface `PreparedStatement`
  Throws:
    `SQLException`
  Returns:
    the description of a `ResultSet` object's columns or `null` if the driver cannot return a `ResultSetMetaData` object

### addBatch

    public void addBatch()
                  throws SQLException

  Description copied from interface: `PreparedStatement`
  Adds a set of parameters to this `PreparedStatement` object's batch of commands.

  Specified by:
    `addBatch` in interface `PreparedStatement`
  Throws:
    `SQLException`
  See Also:
    `Statement.addBatch(java.lang.String)`

Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD